Pokaż tylko komponenty zespołu (nie wszystkie otwarte pliki) VBA

Witam wszystkich,

Pozwólcie, że wyjaśnię moje podejście, muszę zrobić makro, które wyświetla (w debug.print) wszystkie części i złożenia  otwartego pliku Solidworks , a nie skanuje wszystkie otwarte pliki

I chciałbym wiedzieć, czy możliwe jest użycie swmodel.getpathname (tylko nazwy pliku) i użycie go do wyświetlenia tylko tego, co pasuje do tego pliku

Dziękuję za pomoc

VF


acces.png

Aby to zrobić, musisz przejść przez swój montaż.

Przykład oprogramowania:

http://help.solidworks.com/2015/English/api/sldworksapi/Traverse_Assembly_at_Component_Level_Example_VB.htm

I przykład mojej własnej biblioteki makr  (uruchom główny z otwartego złożenia) w zależności od głębokości jaką chcesz usunąć lub nie jakąś linijkę w komentarzu (do pogłębienia)

 '--------------------------------------------------------------------------
' Preconditions:
' 1. Open an assembly document containing nested subassemblies.
' 2. Open the Immediate window.
'
' Postconditions:
' 1. Traverses the assembly.
' 2. Examine the Immediate window.
'---------------------------------------------------------------------------

Option Explicit

Sub TraverseFeatureFeatures(swFeat As SldWorks.Feature, nLevel As Long)

    Dim swSubFeat                   As SldWorks.Feature
    Dim swSubSubFeat                As SldWorks.Feature
    Dim swSubSubSubFeat             As SldWorks.Feature
    Dim sPadStr                     As String
    Dim i                           As Long

    For i = 0 To nLevel
        sPadStr = sPadStr + "  "
    Next i

    While Not swFeat Is Nothing
        If swFeat.GetTypeName = "Reference" Then
        Debug.Print "0:" + sPadStr + swFeat.Name + " [" + swFeat.GetTypeName + "]"
        End If
        'Set swSubFeat = swFeat.GetFirstSubFeature
        'While Not swSubFeat Is Nothing
            'Debug.Print "1:" + sPadStr + "  " + swSubFeat.Name + " [" + swSubFeat.GetTypeName + "]"

            'Set swSubSubFeat = swSubFeat.GetFirstSubFeature
            'While Not swSubSubFeat Is Nothing
                'Debug.Print "2:" + sPadStr + "    " + swSubSubFeat.Name + " [" + swSubSubFeat.GetTypeName + "]"

                'Set swSubSubSubFeat = swSubSubFeat.GetFirstSubFeature
                'While Not swSubSubSubFeat Is Nothing
                    'Debug.Print "3:" + sPadStr + "      " + swSubSubSubFeat.Name + " [" + swSubSubSubFeat.GetTypeName + "]"

                    'Set swSubSubSubFeat = swSubSubSubFeat.GetNextSubFeature()

                'Wend

                'Set swSubSubFeat = swSubSubFeat.GetNextSubFeature()

            'Wend

            'Set swSubFeat = swSubFeat.GetNextSubFeature()

        'Wend

        Set swFeat = swFeat.GetNextFeature

    Wend

End Sub

Sub TraverseComponentFeatures(swComp As SldWorks.Component2, nLevel As Long)

    Dim swFeat As SldWorks.Feature

    Set swFeat = swComp.FirstFeature
    TraverseFeatureFeatures swFeat, nLevel

End Sub


Sub TraverseComponent(swComp As SldWorks.Component2, nLevel As Long)

    Dim vChildComp                  As Variant
    Dim swChildComp                 As SldWorks.Component2
    Dim sPadStr                     As String
    Dim i                           As Long
    

    For i = 0 To nLevel - 1
        sPadStr = sPadStr + "  "
    Next i

    vChildComp = swComp.GetChildren
    For i = 0 To UBound(vChildComp)
        Set swChildComp = vChildComp(i)

        Debug.Print sPadStr & "+" & swChildComp.Name2 & " <" & swChildComp.ReferencedConfiguration & ">"

        TraverseComponentFeatures swChildComp, nLevel
        TraverseComponent swChildComp, nLevel + 1

    Next i

End Sub

Sub TraverseModelFeatures(swModel As SldWorks.ModelDoc2, nLevel As Long)

    Dim swFeat As SldWorks.Feature

    Set swFeat = swModel.FirstFeature
    TraverseFeatureFeatures swFeat, nLevel

End Sub

Sub main()

    Dim swApp                       As SldWorks.SldWorks
    Dim swModel                     As SldWorks.ModelDoc2
    Dim swConfMgr                   As SldWorks.ConfigurationManager
    Dim swConf                      As SldWorks.Configuration
    Dim swRootComp                  As SldWorks.Component2
    Dim StartTime                   As Double
    Dim FinishTime                  As Double
    Dim TotalTime                   As Double
    

    Set swApp = CreateObject("SldWorks.Application")
    Set swModel = swApp.ActiveDoc
    Set swConfMgr = swModel.ConfigurationManager
    Set swConf = swConfMgr.ActiveConfiguration
    Set swRootComp = swConf.GetRootComponent3(True)

    StartTime = Timer ' Start time

    Debug.Print "File = " & swModel.GetPathName

    TraverseModelFeatures swModel, 1

    'If swModel.GetType = SwConst.swDocASSEMBLY Then
        'TraverseComponent swRootComp, 1

    'End If

    FinishTime = Timer ' End time
    TotalTime = FinishTime - StartTime ' Elapsed time
    Debug.Print ("Time = " & TotalTime & " sec")
    

End Sub

 

1 polubienie

Dziękuję 

Zainspirowało mnie to, co zrobiłeś, a dzięki wielu badaniom udało mi się uzyskać to, czego chciałem, zamierzam zamknąć prośbę.

Jeszcze raz dziękuję

1 polubienie